package  
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	/**
	$(CBI)* ...
	$(CBI)* @author talha kaya
	$(CBI)*/
	public class Game extends Sprite
	{
		[Embed(source = 'assets/ggj14talha_music.mp3')]
		public static var music:Class;
		[Embed(source = 'assets/ggj14talha_ambient.mp3')]
		public static var ambient:Class;
		
		public static var instance:Game;
		public var menu:Menu;
		public var gameBoard:GameBoard;
		public static var questionsAnswered:Array;
		public static const NoOfQuestions:int = 8;
		public static const FadeInOutSpeed:Number = 0.02;
		public static const ScaleConst:Number = Main.STAGE.stageHeight / 600;
		private var musicAmbientSound:Sound;
		private var musicMelodySound:Sound;
		private var musicMelodySoundChannel:SoundChannel;
		private var musicMelodySoundTransform:SoundTransform;
		
		public function Game() 
		{
			instance = this;
			questionsAnswered = new Array();
			for (var i:int = 0; i < NoOfQuestions; i++)
			{
				questionsAnswered.push(false);
			}
			questionsAnswered[0] = false;
			
			menu = new Menu();
			addChild(menu);
			musicAmbientSound = new ambient();
			musicAmbientSound.play(0, 99);
			musicMelodySound = new music();
			musicMelodySoundChannel = musicMelodySound.play(0, 99);
			musicMelodySoundTransform = new SoundTransform(0, 0);
			musicMelodySoundChannel.soundTransform = musicMelodySoundTransform;
		}
		
		public static function turnMenuOn():void
		{
			instance.gameBoard.destroy();
			instance.menu = new Menu();
			instance.addChild(instance.menu);
			instance.musicMelodySoundTransform = new SoundTransform(0, 0);
			instance.musicMelodySoundChannel.soundTransform = instance.musicMelodySoundTransform;
		}
		
		public static function turnMenuOff():void
		{
			instance.menu.destroy();
			instance.gameBoard = new GameBoard();
			instance.addChild(instance.gameBoard);
			instance.musicMelodySoundTransform = new SoundTransform(1, 0);
			instance.musicMelodySoundChannel.soundTransform = instance.musicMelodySoundTransform;
		}
	}

}