package  
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import mx.collections.ArrayList;
	/**
	$(CBI)* ...
	$(CBI)* @author talha kaya
	$(CBI)*/
	public class GameBoard extends Sprite
	{
		public static var instance:GameBoard;
		public static var paused:Boolean;
		public var failed:Boolean;
		public var turningOff:Boolean;
		public static const TileWidth:Number = 50;
		public static const TileHeight:Number = 50;
		public static const NoOfTiles:Point = new Point(16, 12);
		public var board:Array;
		public var player2:Player;
		public var door:Pprite;
		public static var monsterDiagonals:ArrayList;
		public static var portals:ArrayList;
		public static var powerUps:ArrayList;
		public static var lockedDoors:ArrayList;
		public static var keys:ArrayList;
		public var powerUpCountDown:int = 0;
		private var basla2:basla;
		
		public function GameBoard() 
		{
			instance = this;
			paused = true;
			alpha = 0;
			addChild(new PhysicsHandler());
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			
			monsterDiagonals = new ArrayList();
			portals = new ArrayList();
			powerUps = new ArrayList();
			lockedDoors = new ArrayList();
			keys = new ArrayList();
			
			graphics.clear();
			graphics.beginFill(0xff000000, 1);
			graphics.drawRect(0, 0, Main.STAGE.stageWidth, Main.STAGE.stageHeight);
			graphics.endFill();
			
			initializeBoardArray();
			createBoard();
			basla2 = new basla();
			basla2.scaleX = basla2.scaleY = 12;
			basla2.x = 400;
			basla2.y = 300;
			addChild(basla2);
			addEventListener(MouseEvent.CLICK, mouseClickHandler);
		}
		
		private function mouseClickHandler(e:MouseEvent):void
		{
			removeEventListener(MouseEvent.CLICK, mouseClickHandler);
			removeChild(basla2);
			paused = false;
		}
		
		private function enterFrameHandler(e:Event):void
		{
			if (turningOff)
			{
				if (alpha > 0)
				{
					alpha -= Game.FadeInOutSpeed;
				}
				else
				{
					if (failed)
					{
						Game.turnMenuOn();
						Game.turnMenuOff();
					}
					else
					{
						Game.turnMenuOn();
					}
				}
			}
			else
			{
				if (alpha < 1)
				{
					alpha += Game.FadeInOutSpeed;
				}
			}
			
			if (!paused)
			{
				if (!turningOff)
				{
					if (PhysicsHandler.overlapping(player2, door))
					{
						turningOff = true;
					}
					var i:int;
					var j:int;
					for (i = 0; i < monsterDiagonals.length; i++)
					{
						var monsterDiagonal:Pprite = monsterDiagonals.getItemAt(i) as Pprite;
						if (PhysicsHandler.overlapping(player2, monsterDiagonal) && !monsterDiagonal.isKilled)
						{
							if (powerUpCountDown > 0)
							{
								monsterDiagonal.isKilled = true;
							}
							else
							{
								turningOff = true;
								paused = true;
								failed = true;
							}
						}
					}
					for (i = 0; i < portals.length; i++)
					{
						var portal:Portal = portals.getItemAt(i) as Portal;
						if (PhysicsHandler.overlapping(player2, portals.getItemAt(i) as Pprite))
						{
							if (!portal.touchingInProgress)
							{
								for (j = 0; j < portals.length; j++)
								{
									if (i != j)
									{
										var portal2:Portal = portals.getItemAt(j) as Portal;
										if (portal.id == portal2.id)
										{
											player2.x = portal2.x;
											player2.y = portal2.y;
											portal2.touchingInProgress = true;
											break;
										}
									}
								}
							}
							portal.touchingInProgress = true;
						}
						else
						{
							portal.touchingInProgress = false;
						}
					}
					if (powerUpCountDown > 0)
					{
						powerUpCountDown --;
					}
					for (i = 0; i < powerUps.length; i++)
					{
						if (PhysicsHandler.overlapping(player2, powerUps.getItemAt(i) as Pprite))
						{
							(powerUps.getItemAt(i) as PowerUp).destroy();
							powerUpCountDown = 150;
						}
					}
					for (i = 0; i < keys.length; i++)
					{
						if (PhysicsHandler.overlapping(player2, keys.getItemAt(i) as Pprite))
						{
							var key:Key = (keys.getItemAt(i) as Key);
							for (j = 0; j < lockedDoors.length; j++)
							{
								var lockedDoor:LockedDoor = lockedDoors.getItemAt(j) as LockedDoor;
								if (lockedDoor.id == key.id)
								{
									lockedDoor.isKilled = true;
								}
							}
							key.destroy();
						}
					}
				}
				
			}
		}
		
		public function destroy():void
		{
			monsterDiagonals.removeAll();
			portals.removeAll();
			powerUps.removeAll();
			lockedDoors.removeAll();
			keys.removeAll();
			removeEventListener(MouseEvent.CLICK, mouseClickHandler);
			removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
			PhysicsHandler.instance.destroy();
			parent.removeChild(this);
		}
		
		public function createBoard():void
		{
			var i:int;
			var j:int;
			for (i = 0; i < NoOfTiles.x; i++)
			{
				for (j = 0; j < NoOfTiles.y; j++)
				{
					var bgTile:BgTile = new BgTile();
					bgTile.x = TileWidth / 2 + i * TileWidth;
					bgTile.y = TileHeight / 2 + j * TileHeight;
					addChild(bgTile);
				}
			}
			for (i = 0; i < NoOfTiles.x; i++)
			{
				for (j = 0; j < NoOfTiles.y; j++)
				{
					if (board[i][j] == 1)
					{
						var pprite:Pprite = new Pprite(true, true);
						pprite.x = TileWidth / 2 + i * TileWidth;
						pprite.y = TileHeight / 2 + j * TileHeight;
						pprite.setCollisionBox(TileWidth - 2, TileHeight - 2);
						pprite.colorCollisionBox(0xff000000);
						addChild(pprite);
					}
					else if (board[i][j] == 7)
					{
						var powerUp2:PowerUp = new PowerUp();
						powerUp2.x = TileWidth / 2 + i * TileWidth;
						powerUp2.y = TileHeight / 2 + j * TileHeight;
						addChild(powerUp2);
					}
					else if (board[i][j] >= 8 && board[i][j] < 9)
					{
						var portal2:Portal = new Portal((board[i][j] - 8) * 10);
						portal2.x = TileWidth / 2 + i * TileWidth;
						portal2.y = TileHeight / 2 + j * TileHeight;
						portal2.colorCollisionBox(portal2.color);
						addChild(portal2);
					}
					else if (board[i][j] == 9)
					{
						var pprite2:Pprite = new Pprite(true, Game.questionsAnswered[5]);
						pprite2.x = TileWidth / 2 + i * TileWidth;
						pprite2.y = TileHeight / 2 + j * TileHeight;
						pprite2.setCollisionBox(TileWidth - 2, TileHeight - 2);
						pprite2.addSprite(new box());
						addChild(pprite2);
					}
					else if (board[i][j] == 10)
					{
						door = new Pprite(false);
						door.x = TileWidth / 2 + i * TileWidth;
						door.y = TileHeight / 2 + j * TileHeight;
						door.setCollisionBox(TileWidth - 2, TileHeight - 2);
						door.colorCollisionBox(0xffffff);
						addChild(door);
					}
					else if (board[i][j] >= 11 && board[i][j] < 12)
					{
						var lockedDoor:LockedDoor = new LockedDoor((board[i][j] - 11) * 10);
						lockedDoor.x = TileWidth / 2 + i * TileWidth;
						lockedDoor.y = TileHeight / 2 + j * TileHeight;
						addChild(lockedDoor);
					}
					else if (board[i][j] >= 12 && board[i][j] < 13)
					{
						var key:Key = new Key((board[i][j] - 12) * 10);
						key.x = TileWidth / 2 + i * TileWidth;
						key.y = TileHeight / 2 + j * TileHeight;
						addChild(key);
					}
				}
			}
			for (i = 0; i < NoOfTiles.x; i++)
			{
				for (j = 0; j < NoOfTiles.y; j++)
				{
					if (board[i][j] == -1)
					{
						player2 = new Player();
						player2.setCollisionBox(32, 32);
						player2.x = TileWidth / 2 + i * TileWidth;
						player2.y = TileHeight / 2 + j * TileHeight;
						//player2.colorCollisionBox(0xffaa4444);
						addChild(player2);
					}
					else if (board[i][j] == 2)
					{
						var monster:Monster = new Monster();
						monster.x = TileWidth / 2 + i * TileWidth;
						monster.y = TileHeight / 2 + j * TileHeight;
						monster.setCollisionBox(32, 32);
						addChild(monster);
					}
					else if (board[i][j] == 3)
					{
						var monster2:MonsterLeftRight = new MonsterLeftRight();
						monster2.x = TileWidth / 2 + i * TileWidth;
						monster2.y = TileHeight / 2 + j * TileHeight;
						monster2.setCollisionBox(32, 32);
						addChild(monster2);
					}
					else if (board[i][j] == 4)
					{
						var monster3:MonsterUpDown = new MonsterUpDown();
						monster3.x = TileWidth / 2 + i * TileWidth;
						monster3.y = TileHeight / 2 + j * TileHeight;
						monster3.setCollisionBox(32, 32);
						addChild(monster3);
					}
				}
			}
			for (i = 0; i < NoOfTiles.x; i++)
			{
				for (j = 0; j < NoOfTiles.y; j++)
				{
					if (board[i][j] == 5)
					{
						var monster4:MonsterDiagonal = new MonsterDiagonal();
						monster4.x = TileWidth / 2 + i * TileWidth;
						monster4.y = TileHeight / 2 + j * TileHeight;
						monster4.setCollisionBox(32, 32);
						addChild(monster4);
					}
				}
			}
			
		}
		
		public function initializeBoardArray():void
		{
			board = new Array();
			for (var i:int = 0; i < NoOfTiles.x; i++)
			{
				board.push(new Array());
				for (var j:int = 0; j < NoOfTiles.y; j++)
				{
					if (i == 0 || j == 0 || i == NoOfTiles.x - 1 || j == NoOfTiles.y - 1)
					{
						board[i].push(1);
					}
					else
					{
						board[i].push(0);
					}
				}
			}
			
			
			for (var k:int = 0; k < Game.NoOfQuestions; k++)
			{
				if (Game.questionsAnswered[k])
				{
					QuestionHandler.effectBoard(k, board);
				}
			}
			board[1][10] = -1;
			board[14][1] = 10;
		}
		
		public static function monsterTouchHandler(_monster:Pprite):void
		{
			if (instance.powerUpCountDown <= 0)
			{
				instance.turningOff = true;
				paused = true;
				instance.failed = true;
			}
			else
			{
				_monster.isKilled = true;
			}
		}
	}

}