package  
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import mx.collections.ArrayList;
	/**
	$(CBI)* ...
	$(CBI)* @author talha kaya
	$(CBI)*/
	public class Menu extends Sprite
	{
		[Embed(source='C:/WINDOWS/Fonts/verdana.ttf', fontFamily="Verdana", fontWeight="regular", embedAsCFF="false")]
		public var Verdana:Class;
		
		private var questionsStartY:Number = Main.STAGE.stageHeight / 3;
		private var questionsTextSize:Number = 20;
		private var textFormat:TextFormat;
		private var textFields:Array;
		private var textIdMouseOn:int;
		private var turningOff:Boolean;
		private var bgTiles:ArrayList;
		
		public function Menu() 
		{
			alpha = 0;
			
			graphics.clear();
			graphics.beginFill(0xff000000, 1);
			graphics.drawRect(0, 0, Main.STAGE.stageWidth, Main.STAGE.stageHeight);
			graphics.endFill();
			textFormat = new TextFormat();
			textFormat.align = TextFormatAlign.CENTER;
			textFormat.color = 0xFFFFFFFF;
			textFormat.font = "Verdana";
			textFormat.size = questionsTextSize;
			
			textFields = new Array();
			
			for (var i:int = 0; i < Game.NoOfQuestions; i++)
			{
				var textField:TextField = new TextField();
				textField.width = Main.STAGE.stageWidth;
				textField.y = questionsStartY + i * (Main.STAGE.stageHeight - questionsStartY) / Game.NoOfQuestions;
				textField.defaultTextFormat = textFormat;
				textField.selectable = false;
				textField.text = QuestionHandler.getText(i);
				addChild(textField);
				textFields.push(textField);
			}
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			addEventListener(MouseEvent.CLICK, mouseClickHandler);
			var titleText:Title = new Title();
			titleText.x = Main.STAGE.stageWidth / 2;
			titleText.y = Main.STAGE.stageHeight / 6;
			addChild(titleText);
			
			var textField2:TextField = new TextField();
			textField2.width = Main.STAGE.stageWidth;
			textField2.y = questionsStartY + (-1) * (Main.STAGE.stageHeight - questionsStartY) / Game.NoOfQuestions;
			textField2.defaultTextFormat = textFormat;
			textField2.selectable = false;
			textField2.text = "Kod, Grafik: Talha           Dizayn: Talha, Nazire           Müzik:Doğaç";
			textField2.scaleX = textField2.scaleY = 1;
			textField2.alpha = 0.5;
			addChild(textField2);
			
			bgTiles = new ArrayList();
		}
		
		private function mouseClickHandler(e:MouseEvent):void
		{
			if (!turningOff && textIdMouseOn >= 0 && textIdMouseOn < Game.NoOfQuestions && !Game.questionsAnswered[textIdMouseOn])
			{
				Game.questionsAnswered[textIdMouseOn] = true;
				turningOff = true;
			}
		}
		
		public function enterFrameHandler(e:Event):void
		{
			if (!turningOff)
			{
				textIdMouseOn = Math.floor((Main.STAGE.mouseY - questionsStartY) * Game.NoOfQuestions / (Main.STAGE.stageHeight - questionsStartY));
				for (var i:int = 0; i < Game.NoOfQuestions; i++)
				{
					if (Game.questionsAnswered[i])
					{
						textFields[i].alpha = 1;
					}
					else
					{
						if (i == textIdMouseOn)
						{
							textFields[i].alpha = 0.5 + 0.3 * Math.random();
						}
						else
						{
							textFields[i].alpha = (0.5 + 0.3 * Math.random()) / 3;
						}
					}
				}
			}
			
			if (turningOff)
			{
				if (alpha > 0)
				{
					alpha -= Game.FadeInOutSpeed;
				}
				else
				{
					Game.turnMenuOff();
				}
			}
			else
			{
				if (alpha < 1)
				{
					alpha += Game.FadeInOutSpeed;
				}
			}
		}
		
		public function destroy():void
		{
			var i:int;
			for (i = 0; i < textFields.length; i++)
			{
				removeChild(textFields[i]);
			}
			removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
			removeEventListener(MouseEvent.CLICK, mouseClickHandler);
			parent.removeChild(this);
		}
	}

}