package  
{
	import flash.display.Sprite;
	import flash.events.Event;
	import mx.collections.ArrayList;
	/**
	$(CBI)* ...
	$(CBI)* @author talha kaya
	$(CBI)*/
	public class PhysicsHandler extends Sprite
	{
		public static var instance:PhysicsHandler;
		public static var solidObjects:ArrayList;
		public static var nonsolidObjects:ArrayList;
		
		public function PhysicsHandler() 
		{
			if (instance != null)
			{
				instance.destroy();
				instance = null;
			}
			instance = this;
			solidObjects = new ArrayList();
			nonsolidObjects = new ArrayList();
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
		}
		
		private function enterFrameHandler(e:Event):void
		{
			if (!GameBoard.paused)
			{
				positionNonsolidObjects();
				collisionCheck();
			}
		}
		
		private function positionNonsolidObjects():void
		{
			for (var i:int = 0; i < nonsolidObjects.length; i++)
			{
				var nonsolidObjectsI:Pprite = nonsolidObjects.getItemAt(i) as Pprite;
				if (nonsolidObjectsI.speed.x != 0 || nonsolidObjectsI.speed.y != 0)
				{
					nonsolidObjectsI.x += nonsolidObjectsI.speed.x;
					nonsolidObjectsI.y += nonsolidObjectsI.speed.y;
				}
			}
		}
		
		private function collisionCheck():void
		{
			var solidObjectsI:Pprite;
			var solidObjectsJ:Pprite;
			var solidObjectsK:Pprite;
			for (var i:int = 0; i < solidObjects.length; i++)
			{
				solidObjectsI = solidObjects.getItemAt(i) as Pprite;
				if (!solidObjectsI.isStatic)
				{
					if (solidObjectsI.speed.x != 0 || solidObjectsI.speed.y != 0)
					{
						var objectICollidingX:Boolean = false;
						var objectICollidingY:Boolean = false;
						for (var j:int = 0; j < solidObjects.length; j++)
						{
							if (i != j)
							{
								solidObjectsJ = solidObjects.getItemAt(j) as Pprite;
								if (solidObjectsJ.isStatic)
								{
									if (overlappingWithSpeed(solidObjectsI, solidObjectsJ))
									{
										if (Math.abs(solidObjectsI.x - solidObjectsJ.x) > Math.abs(solidObjectsI.y - solidObjectsJ.y))
										{
											objectICollidingX = true;
										}
										else
										{
											objectICollidingY = true;
										}
									}
								}
								else
								{
									if (overlappingWithSpeed(solidObjectsI, solidObjectsJ))
									{
										if ((solidObjectsI.isPlayer && solidObjectsJ.isMonster) || (solidObjectsJ.isPlayer && solidObjectsI.isMonster))
										{
											if (solidObjectsJ.isMonster)
											{
												if (!solidObjectsJ.isKilled)
												{
													GameBoard.monsterTouchHandler(solidObjectsJ);
												}
											}
											else
											{
												if (!solidObjectsI.isKilled)
												{
													GameBoard.monsterTouchHandler(solidObjectsI);
												}
											}
										}
										objectICollidingX = true;
										objectICollidingY = true;
										solidObjectsI.x += solidObjectsI.speed.x / 2;
										solidObjectsI.y += solidObjectsI.speed.y / 2;
										var objectJNotColliding:Boolean = true;
										for (var k:int = 0; k < solidObjects.length; k++)
										{
											if (k != j && k != i)
											{
												solidObjectsK = solidObjects.getItemAt(k) as Pprite;
												if (overlappingWithSpeed(solidObjectsJ, solidObjectsK))
												{
													solidObjectsI.x -= solidObjectsI.speed.x / 2;
													solidObjectsI.y -= solidObjectsI.speed.y / 2;
													objectJNotColliding = false;
												}
											}
										}
										if (objectJNotColliding)
										{
											solidObjectsJ.x += solidObjectsI.speed.x / 2;
											solidObjectsJ.y += solidObjectsI.speed.y / 2;
										}
									}
								}
							}
						}
						if (!objectICollidingX)
						{
							solidObjectsI.x += solidObjectsI.speed.x;
						}
						else
						{
							solidObjectsI.speed.x = 0;
						}
						if (!objectICollidingY)
						{
							solidObjectsI.y += solidObjectsI.speed.y;
						}
						else
						{
							solidObjectsI.speed.y = 0;
						}
						
						//FRICTION HANDLING
						if (solidObjectsI.speed.x > 0)
						{
							if (solidObjectsI.speed.x > solidObjectsI.friction)
							{
								solidObjectsI.speed.x -= solidObjectsI.friction;
							}
							else
							{
								solidObjectsI.speed.x = 0;
							}
						}
						else if (solidObjectsI.speed.x < 0)
						{
							if (solidObjectsI.speed.x > solidObjectsI.friction)
							{
								solidObjectsI.speed.x = 0;
							}
							else
							{
								solidObjectsI.speed.x += solidObjectsI.friction;
							}
						}
						if (solidObjectsI.speed.y > 0)
						{
							if (solidObjectsI.speed.y > solidObjectsI.friction)
							{
								solidObjectsI.speed.y -= solidObjectsI.friction;
							}
							else
							{
								solidObjectsI.speed.y = 0;
							}
						}
						else if (solidObjectsI.speed.y < 0)
						{
							if (solidObjectsI.speed.y > solidObjectsI.friction)
							{
								solidObjectsI.speed.y = 0;
							}
							else
							{
								solidObjectsI.speed.y += solidObjectsI.friction;
							}
						}
					}
				}
			}
		}
		
		public static function overlapping(s1:Pprite, s2:Pprite):Boolean
		{
			return !(s1.x - s1.collisionBox.x / 2 > s2.x + s2.collisionBox.x / 2 || s2.x - s2.collisionBox.x / 2 > s1.x + s1.collisionBox.x / 2 || s1.y - s1.collisionBox.y / 2 > s2.y + s2.collisionBox.y / 2 || s2.y - s2.collisionBox.x / 2 > s1.y + s1.collisionBox.y / 2);
		}
		
		private function overlappingWithSpeed(s1:Pprite, s2:Pprite):Boolean
		{
			return !(s1.x + s1.speed.x - s1.collisionBox.x / 2 > s2.x + s2.collisionBox.x / 2 || s2.x - s2.collisionBox.x / 2 > s1.x + s1.collisionBox.x / 2 + s1.speed.x || s1.y + s1.speed.y - s1.collisionBox.y / 2 > s2.y + s2.collisionBox.y / 2 || s2.y - s2.collisionBox.x / 2 > s1.y + s1.collisionBox.y / 2 + s1.speed.y);
		}
		
		private function overlappingY(s1:Pprite, s2:Pprite):Boolean
		{
			return !(s1.y + s1.speed.y - s1.collisionBox.y / 2 > s2.y + s2.collisionBox.y / 2 || s2.y - s2.collisionBox.x / 2 > s1.y + s1.collisionBox.y / 2 + s1.speed.y);
		}
		
		private function overlappingX(s1:Pprite, s2:Pprite):Boolean
		{
			return !(s1.x + s1.speed.x - s1.collisionBox.x / 2 > s2.x + s2.collisionBox.x / 2 || s2.x - s2.collisionBox.x / 2 > s1.x + s1.collisionBox.x / 2 + s1.speed.x);
		}
		
		public function destroy():void
		{
			var i:int
			for (i = 0; i < solidObjects.length; i++)
			{
				solidObjects.getItemAt(i).destroy();
			}
			for (i = 0; i < nonsolidObjects.length; i++)
			{
				nonsolidObjects.getItemAt(i).destroy();
			}
			removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
			if (parent != null)
			{
				parent.removeChild(this);
			}
		}
	}

}