package  
{
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
	/**
	$(CBI)* ...
	$(CBI)* @author talha kaya
	$(CBI)*/
	public class Player extends Pprite
	{
		private var keyboardUp:Boolean;
		private var keyboardDown:Boolean;
		private var keyboardLeft:Boolean;
		private var keyboardRight:Boolean;
		private const maxSpeed:Number = 5;
		
		public function Player() 
		{
			super(true, false);
			friction = 0.5;
			isPlayer = true;
			Main.STAGE.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			Main.STAGE.addEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
			Main.STAGE.addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			addSprite(new player());
		}
		
		private function enterFrameHandler(e:Event):void
		{
			
			if (keyboardUp && keyboardLeft)
			{
				speed.x = -maxSpeed / 1.4;
				speed.y = -maxSpeed / 1.4;
			}
			else if (keyboardDown && keyboardLeft)
			{
				speed.x = -maxSpeed / 1.4;
				speed.y = maxSpeed / 1.4;
			}
			else if (keyboardUp && keyboardRight)
			{
				speed.x = maxSpeed / 1.4;
				speed.y = -maxSpeed / 1.4;
			}
			else if (keyboardDown && keyboardRight)
			{
				speed.x = maxSpeed / 1.4;
				speed.y = maxSpeed / 1.4;
			}
			else if (keyboardUp)
			{
				speed.y = -maxSpeed;
			}
			else if (keyboardDown)
			{
				speed.y = maxSpeed;
			}
			else if (keyboardLeft)
			{
				speed.x = -maxSpeed;
			}
			else if (keyboardRight)
			{
				speed.x = maxSpeed;
			}
			sprite.rotation = Math.atan2(speed.y, speed.x) * 180 / Math.PI;
		}
		
		private function keyDownHandler(event:KeyboardEvent):void
		{
			var key:uint = event.keyCode;
			switch (key) {
				case Keyboard.LEFT :
				case Keyboard.A:
					keyboardLeft = true;
					break;
				case Keyboard.RIGHT :
				case Keyboard.D:
					keyboardRight = true;
					break;
				case Keyboard.UP :
				case Keyboard.W:
					keyboardUp = true;
					break;
				case Keyboard.DOWN :
				case Keyboard.S:
					keyboardDown = true;
					break;
			}
		}
		
		private function keyUpHandler(event:KeyboardEvent):void
		{
			var key:uint = event.keyCode;
			switch (key) {
				case Keyboard.LEFT :
				case Keyboard.A:
					keyboardLeft = false;
					break;
				case Keyboard.RIGHT :
				case Keyboard.D:
					keyboardRight = false;
					break;
				case Keyboard.UP :
				case Keyboard.W:
					keyboardUp = false;
					break;
				case Keyboard.DOWN :
				case Keyboard.S:
					keyboardDown = false;
					break;
			}
		}
		
		public override function destroy():void
		{
			Main.STAGE.removeEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			Main.STAGE.removeEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
			Main.STAGE.removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
			super.destroy();
		}
	}

}